%K=1000; k=1; M=10; m=0.1; c=.01; C=.1; %sistema buono%
K=100; k=50; M=1; m=0.1; c=.01; C=.01; %sistema cattivo%

V=[M 0 0 0;0 1 0 0;m 0 m 0;0 0 0 1];
Aa=[-c -k C K;1 0 0 0;0 0 -C -K;0 0 1 0];
Bb=[1 0 0 0]';
A=inv(V)*Aa;
B=inv(V)*Bb;
C=eye(4);
D=[0 0 0 0]';

%Riduzione delle matrici
Crid=[C(2,:);C(4,:)];
Drid=[D(2);D(4)];

%Ricerca dei poli sel sistema fisico, necessaria pee il posizionamento di quelli dell'osservatore

sys=ss(A,B,C,D);
figure(1)
pzmap(sys)
title('Posizione dei poli -- sistema fisico');

av_A=eig(A);
P=[av_A(1)-20;av_A(2)-20;av_A(3)-15;av_A(4)-15];
Lt=place(A',Crid',P);
L=Lt';

Aoss=A-L*Crid;
Boss1=B-L*Drid;
Boss=L;
Boss(:,3)=Boss1;
Coss=eye(4);
Doss=[0 0 0; 0 0 0; 0 0 0; 0 0 0 ];

sysoss=ss(Aoss,Boss,Coss,Doss);
figure(2)
pzmap(sysoss)
title('Posizione dei poli -- osservatore')
